
#define FALSE 0
#define TRUE  1
#define TOO_SMALL 0
#define BIG_ENOUGH 1

#include "read_rc.h"

class xtc_window
{
  public:

    /* Creating window */
    xtc_window(int argc, char *argv[], Display *display, Window mainw,
        int _display_x, int _display_y, 
        unsigned int _display_width, unsigned int _display_height,
        unsigned int _display_border_width, unsigned int _depth,
        XFontStruct *_font_info_first, 
        XFontStruct *_font_info_second, 
        XFontStruct *_font_info_third,
        int screen_num, int xposi, int yposi, int steps, char _at,
        XEvent *report, sub_menu_struct *_menu);

    inline int is_inside()
    {
      return inside_window;
    }

    /* Notify procedures */
    void check_buttons();
    void cycle_buttons();
    int check_notifiers();
    int get_next_x()
    {
      return title_x_end;
    }
    int gettitlewidth();

  private:
  
    /* Window setup */
    void Set_properties();
    void Create_window();
    void Set_graphics_context();
    void Set_cursor(int argc, char *argv[]);

    /* Notify procedures */
    int  type_focus();

    /* Moving window */
    void window_up();
    void window_down();

    /* Actions */
    void Raise_lower_window();
    void Pick_window();
    void Unpick_window();
    
    /* Painting window */
    void draw_window(int do_paint);
    void draw_submenu(sub_menu_struct *sub_menu, int xpos, int *ypos, int *row_width, int do_paint);
    void init_buttons(GC gc, int xpos, int ypos, 
        int *row_width, char *string, char *data, int do_paint, int type);
    void draw_button();
    void unpress_button();
    void activate_button();
    void inactivate_button();
    
    /* Basic variables */
    Window mainw, window;
    int x, y, title_x, title_x_end;
    char at;
    unsigned int  width, height;
    XEvent *report;
    sub_menu_struct *menu;
    
    /* Root window */
    Display *display;
    int screen_num;
    char **argv;
    int argc;
    
    int           display_x,     display_y;
    unsigned int  display_width, display_height;
    unsigned int  display_border_width, display_depth; 
    
    /* Basic window */
    unsigned int  border_width, depth; 
    int window_size;
    
    XTextProperty windowName, iconName;
    char *window_name, *icon_name;

    // Moving window
    int raise_steps, raise_width, pick_steps, pick_width;

    // Class hints
    XWMHints *wm_hints;
    XClassHint *class_hints;
    XSizeHints *size_hints;

    /* Colormap variables */
    Pixmap icon_pixmap, shape_pixmap, graypixmap;
    GC gc;
    XGCValues gcvalues;
    unsigned long valuemask, gcvaluemask, inputmask;
    XFontStruct *font_info_first, *font_info_second, *font_info_third;
    char *backg_bmp;  
    Cursor cursor;
    XSetWindowAttributes setwinattr;

    // Window items
    menubutton *first_button;
    menubutton *button;
    
    /* Window properties */
    int inside_window, window_raised, button_not_drawn, 
        inside_button, check_button;
        
    // For delaying window dropping:
    clock_t begin, end;
    int do_leave;

};


